<?php
/**
@author ABA Bank Developer
@copyright payway.com.kh 2019
@license ABA Bank License version 1
*/

/**
 * Short description for file
 *
 * Long description for file (if any)...
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.01 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_01.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   CategoryName
 * @package    PackageName
 * @author     Original Author <author@example.com>
 * @author     Another Author <another@example.com>
 * @copyright  1997-2005 The PHP Group
 * @license    http://www.php.net/license/3_01.txt  PHP License 3.01
 * @version    SVN: $Id$
 * @link       http://pear.php.net/package/PackageName
 * @see        NetOther, Net_Sample::Net_Sample()
 * @since      File available since Release 1.2.0
 * @deprecated File deprecated in Release 2.0.0
 */

/**
 * This is a "Docblock Comment," also known as a "docblock."  The class'
 * docblock, below, contains a complete description of how to write these.
*/

class PayWayApi
{
    /*public static function getHash($transactionId, $amount, $items, $shippingCost)*/
    public static function getHash($transactionId, $amount, $items)
    {
        $hash = base64_encode(hash_hmac('sha512', Tools::safeOutput(Configuration::get('ABA_PAYWAY_MERCHANT_ID')) . $transactionId . $amount . $items, Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_KEY')), true));
        return $hash;
    }
    
    public static function getEndPoint()
    {
        if (Configuration::get('ABA_PAYWAY_SANDBOX_MODE') && Configuration::get('ABA_PAYWAY_API_ENDPOINT_SANDBOX')) {
            return Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_ENDPOINT_SANDBOX'));
        } else {
            return Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_ENDPOINT'));
        }
    }
    
    public static function getBaseUrl()
    {
        if (Configuration::get('ABA_PAYWAY_SANDBOX_MODE') && Configuration::get('ABA_PAYWAY_API_BASE_URL_SANDBOX')) {
            return Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_BASE_URL_SANDBOX'));
        } else {
            return Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_BASE_URL'));
        }
    }
    
    public static function getReturnUrl($queryString = [])
    {
		return base64_encode(Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_CALL_BACK_URL')) . $queryString);
    }
    
    public static function getRedirectUrl($queryString = [])
    {
        $queryString = !empty($queryString) ? '?' . http_build_query($queryString) : '';
        $detect = new Mobile_Detect;
        if ($detect->isMobile()) {
            return base64_encode(Tools::safeOutput(Configuration::get('ABA_PAYWAY_SUCCESSFUL_REDIRECTION_URL_MOBILE')) . $queryString);
        }
        return base64_encode(Tools::safeOutput(Configuration::get('ABA_PAYWAY_SUCCESSFUL_REDIRECTION_URL_WEB')) . $queryString);
    }
    
    public function getCancelUrl($queryString = [])
    {
        $queryString = !empty($queryString) ? '?' . http_build_query($queryString) : '';
        return base64_encode(Tools::safeOutput(Tools::getShopDomainSsl(true, true) . __PS_BASE_URI__ . 'module/payway/cancel') . $queryString);
    }
    
    public function getPushUrl($queryString = [])
    {
        $queryString = !empty($queryString) ? '?' . http_build_query($queryString) : '';
        return base64_encode(Tools::safeOutput(Tools::getShopDomainSsl(true, true) . __PS_BASE_URI__ . 'module/payway/pushback') . $queryString);
    }
    
    public function getCssUrl()
    {
        if (Configuration::get('ABA_PAYWAY_SANDBOX_MODE')) {
            return Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_CSS_URL_SANDBOX'));
        } else {
            return Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_CSS_URL'));
        }
    }
    
    public function getJsUrl()
    {
        if (Configuration::get('ABA_PAYWAY_SANDBOX_MODE')) {
            return Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_JS_URL_SANDBOX'));
        } else {
            return Tools::safeOutput(Configuration::get('ABA_PAYWAY_API_JS_URL'));
        }
    }
}
