<?php
/**
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2015 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
 * @since 1.5.0
 */
class PaywayCancelModuleFrontController extends ModuleFrontController
{
    public function __construct()
    {
        parent::__construct();
    }
    public function init()
    {
        parent::init();
    }
    public function initContent()
    {
        parent::initContent();
        $id_order = Tools::getValue('id_order');
        $order_data = explode("-", $id_order);
        $id_order = $order_data[0];
        if (Validate::isUnsignedId($id_order)) {
            $order = new Order((int) $id_order);
        }
        if (!isset($order) || !Validate::isLoadedObject($order)) {
            die($this->trans('The order was not found.', array(), 'Modules.PayWay.Error'));
        }
        $state = $order->getCurrentState();
        if (!in_array($state, array(Configuration::get('ABA_PAYWAY_PAYMENT_SUCCESS')))) {
            $history = new OrderHistory();
            $history->id_order = (int)$order->id;
            $history->changeIdOrderState(
                (int)Configuration::get('ABA_PAYWAY_PAYMENT_ERROR'),
                (int)($order->id)
            );

            $order->setCurrentState((int)Configuration::get('ABA_PAYWAY_PAYMENT_ERROR'));

            foreach ($order->getProductsDetail() as $product) {
                if (!StockAvailable::dependsOnStock($product['id_product'])) {
                    StockAvailable::updateQuantity($product['product_id'], $product['product_attribute_id'], (int) $product['product_quantity'], $order->id_shop);
                }
            }

            Tools::redirect($this->context->link->getPageLink('order', true, null, 'submitReorder&id_order=' . (int) $order->id));
        }

        Tools::redirect('index.php?controller=order-confirmation&id_cart='.Tools::getValue('id_cart').'&id_module='.Tools::getValue('id_module').'&id_order='.$id_order.'&key='.Tools::getValue('key'));
    }
}
