<?php
/**
@author ABA Bank Developer
@copyright payway.com.kh 2019
@license ABA Bank License version 1
*/

/**
 * Short description for file
 *
 * Long description for file (if any)...
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.01 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_01.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   CategoryName
 * @package    PackageName
 * @author     Original Author <author@example.com>
 * @author     Another Author <another@example.com>
 * @copyright  1997-2005 The PHP Group
 * @license    http://www.php.net/license/3_01.txt  PHP License 3.01
 * @version    SVN: $Id$
 * @link       http://pear.php.net/package/PackageName
 * @see        NetOther, Net_Sample::Net_Sample()
 * @since      File available since Release 1.2.0
 * @deprecated File deprecated in Release 2.0.0
 */

/**
 * This is a "Docblock Comment," also known as a "docblock."  The class'
 * docblock, below, contains a complete description of how to write these.
 */

if (!defined('_PS_VERSION_')) {
    exit;
}

class PayWayInstall
{
    /**
     * Set configuration table
     */
    public function updateConfiguration()
    {
        Configuration::updateValue('ABA_PAYWAY_API_BASE_URL', '');
        Configuration::updateValue('ABA_PAYWAY_API_BASE_URL_SANDBOX', '');
        Configuration::updateValue('ABA_PAYWAY_API_ENDPOINT', '');
        Configuration::updateValue('ABA_PAYWAY_API_ENDPOINT_SANDBOX', '');
        Configuration::updateValue('ABA_PAYWAY_API_CALL_BACK_URL', '');
        Configuration::updateValue('ABA_PAYWAY_SUCCESSFUL_REDIRECTION_PAGE', '');
        Configuration::updateValue('ABA_PAYWAY_API_KEY', '');
        Configuration::updateValue('ABA_PAYWAY_MERCHANT_ID', '');
        Configuration::updateValue('ABA_PAYWAY_API_CSS_URL', '');
        Configuration::updateValue('ABA_PAYWAY_API_JS_URL', '');
        Configuration::updateValue('ABA_PAYWAY_API_CSS_URL_SANDBOX', '');
        Configuration::updateValue('ABA_PAYWAY_API_JS_URL_SANDBOX', '');
    }

    /**
     * Delete PayWay configuration
     */
    public function deleteConfiguration()
    {
        Configuration::deleteByName('ABA_PAYWAY_SANDBOX_MODE');
        Configuration::deleteByName('ABA_PAYWAY_API_BASE_URL', '');
        Configuration::deleteByName('ABA_PAYWAY_API_BASE_URL_SANDBOX', '');
        Configuration::deleteByName('ABA_PAYWAY_API_ENDPOINT');
        Configuration::deleteByName('ABA_PAYWAY_API_ENDPOINT_SANDBOX');
        Configuration::deleteByName('ABA_PAYWAY_API_CALL_BACK_URL', '');
        Configuration::deleteByName('ABA_PAYWAY_SUCCESSFUL_REDIRECTION_PAGE', '');
        Configuration::deleteByName('ABA_PAYWAY_API_KEY');
        Configuration::deleteByName('ABA_PAYWAY_MERCHANT_ID');
        Configuration::deleteByName('ABA_PAYWAY_PAYMENT_OPTIONS');
        Configuration::deleteByName('ABA_PAYWAY_LOGO_IMAGE_SIZE');
        
        Configuration::deleteByName('ABA_PAYWAY_BG_COLOR');
        
        Configuration::deleteByName('ABA_PAYWAY_SANDBOX_MODE');

        Configuration::deleteByName('ABA_PAYWAY_PAYMENT_PREORDER');
        Configuration::deleteByName('ABA_PAYWAY_WAITING_PAYMENT');
        Configuration::deleteByName('ABA_PAYWAY_PAYMENT_SUCCESS');
        Configuration::deleteByName('ABA_PAYWAY_PAYMENT_ERROR');

        Configuration::deleteByName('ABA_PAYWAY_POPUP_HIDE_BTN');
        Configuration::deleteByName('ABA_PAYWAY_API_CSS_URL');
        Configuration::deleteByName('ABA_PAYWAY_API_JS_URL');
        Configuration::deleteByName('ABA_PAYWAY_API_CSS_URL_SANDBOX');
        Configuration::deleteByName('ABA_PAYWAY_API_JS_URL_SANDBOX');
    }

    /**
     * Create a new order state
     */
    public function createOrderState()
    {
        $value1 = $this->addState('ABA PayWay - Pending', '#FF8C00');
        $value2 = $this->addState('ABA PayWay - Processing Payment', '#00CDD4');
        $value3 = $this->addState('ABA PayWay - Successful', '#009688', true);
        $value4 = $this->addState('ABA PayWay - Payment Failed', '#8f0621');

        if (!Configuration::get('ABA_PAYWAY_PAYMENT_PREORDER')) {
            Configuration::updateValue('ABA_PAYWAY_PAYMENT_PREORDER', $value1);
        }
        if (!Configuration::get('ABA_PAYWAY_WAITING_PAYMENT')) {
            Configuration::updateValue('ABA_PAYWAY_WAITING_PAYMENT', $value2);
        }
        if (!Configuration::get('ABA_PAYWAY_PAYMENT_SUCCESS')) {
            Configuration::updateValue('ABA_PAYWAY_PAYMENT_SUCCESS', $value3);
        }
        if (!Configuration::get('ABA_PAYWAY_PAYMENT_ERROR')) {
            Configuration::updateValue('ABA_PAYWAY_PAYMENT_ERROR', $value4);
        }
    }

    private function addState($en, $color, $paid = false)
    {
        $states = OrderState::getOrderStates((int) Context::getContext()->language->id);
        foreach ($states as $state) {
            if (in_array($en, $state)) {
                $id_state = $state['id_order_state'];
                return $id_state;/*If state exists, return state id*/
            }
        }

        /*else create new state and return created state id*/
        $orderState = new OrderState();
        $orderState->name = array();
        foreach (Language::getLanguages() as $language) {
            $orderState->name[$language['id_lang']] = $en;
        }
        $orderState->send_email     = $paid;
        $orderState->module_name    = 'payway';
        $orderState->color          = $color;
        $orderState->hidden         = false;
        $orderState->delivery       = false;
        $orderState->logable        = false;
        $orderState->paid           = $paid;

        if ($orderState->add()) {
            $data1 = dirname(__FILE__).'/views/img/os_payway.gif';
            $data2 = dirname(__FILE__).'/../../img/os/'.(int)$orderState->id.'.gif';
            copy($data1, $data2);
            return $orderState->id;
        }
    }
}
